local M = {}
M.type = "auxiliary"
M.relevantDevice = nil

local steeringMode = 0
local steeringModeNames = {"Opposite", "Parallel"}
local steeringMultiplierNames = {"1","0.5","0"}
local rearSteeringMultiplier = 0
local rearSteeringValue = 1
local frontSteeringMultiplier = 0
local frontSteeringValue = 1
local FrontMultiplier = 1
local RearMultiplier = 1

local function init(jbeamData)
	electrics.values.FrontSteerInput = 0
	electrics.values.RearSteerInput = 0
end

local function updateGFX(dt)
	electrics.values.FrontSteerInput = electrics.values.steering_input * FrontMultiplier * frontSteeringValue
	electrics.values.RearSteerInput = electrics.values.steering_input * RearMultiplier * rearSteeringValue
end

local function updateSteeringMode()
  gui.message("Steering Mode Set To " .. steeringModeNames[steeringMode+1]) -- we use mode+1 here because lua tables start at 1, so mode 0 (Opposite) would be at modeNames[1]

	if steeringMode == 0 then
		FrontMultiplier = 1
		RearMultiplier = 1
	elseif steeringMode == 1 then
		FrontMultiplier = 1
		RearMultiplier = -1
	end
end

local function nextMode()
  steeringMode = (steeringMode + 1) % 2 -- wrap around to 0 if it's >= 2
  updateSteeringMode()
end



local function updateRearSteeringMultiplier()
  gui.message("Rear Steering Multiplier Set To " .. steeringMultiplierNames[rearSteeringMultiplier+1]) -- we use mode+1 here because lua tables start at 1, so mode 0 (Opposite) would be at modeNames[1]

	if rearSteeringMultiplier == 0 then
		rearSteeringValue = 1
	elseif rearSteeringMultiplier == 1 then
		rearSteeringValue = 0.5
	elseif rearSteeringMultiplier == 2 then
		rearSteeringValue = 0
	end
end

local function nextRearMultiplier()
  rearSteeringMultiplier = (rearSteeringMultiplier + 1) % 3 -- wrap around to 0 if it's >= 2
  updateRearSteeringMultiplier()
end

local function updateFrontSteeringMultiplier()
  gui.message("Front Steering Multiplier Set To " .. steeringMultiplierNames[frontSteeringMultiplier+1]) -- we use mode+1 here because lua tables start at 1, so mode 0 (Opposite) would be at modeNames[1]

	if frontSteeringMultiplier == 0 then
		frontSteeringValue = 1
	elseif frontSteeringMultiplier == 1 then
		frontSteeringValue = 0.5
	elseif frontSteeringMultiplier == 2 then
		frontSteeringValue = 0
	end
end

local function nextFrontMultiplier()
  frontSteeringMultiplier = (frontSteeringMultiplier + 1) % 3 -- wrap around to 0 if it's >= 2
  updateFrontSteeringMultiplier()
end


-- at the end of the lua as always
M.init = init
M.updateGFX = updateGFX

M.nextRearMultiplier = nextRearMultiplier
M.nextFrontMultiplier = nextFrontMultiplier
M.nextMode = nextMode
M.previousMode = previousMode
return M